/* -*- mode: c ; c-file-style: "canonware-c-style" -*-
 ******************************************************************************
 *
 * Copyright (C) 1996-2004 Jason Evans <jasone@canonware.com>.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice(s), this list of conditions and the following disclaimer
 *    unmodified other than the allowable addition of one or more
 *    copyright notices.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice(s), this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER(S) ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 *
 * Version: Onyx 5.1.1
 *
 ******************************************************************************/

void
nxo_string_new(cw_nxo_t *a_nxo, bool a_locking, uint32_t a_len);

void
nxo_string_substring_new(cw_nxo_t *a_nxo, cw_nxo_t *a_string,
			 uint32_t a_offset, uint32_t a_len);

void
nxo_string_copy(cw_nxo_t *a_to, cw_nxo_t *a_from);

void
nxo_string_cstring(cw_nxo_t *a_to, cw_nxo_t *a_from, cw_nxo_t *a_thread);

uint32_t
nxo_string_len_get(const cw_nxo_t *a_nxo);

void
nxo_string_el_get(const cw_nxo_t *a_nxo, cw_nxoi_t a_offset, char *r_el);

void
nxo_string_el_set(cw_nxo_t *a_nxo, char a_el, cw_nxoi_t a_offset);

#ifdef CW_THREADS
void
nxo_string_lock(cw_nxo_t *a_nxo);

void
nxo_string_unlock(cw_nxo_t *a_nxo);
#else
#define nxo_string_lock(a_nxo)
#define nxo_string_unlock(a_nxo)
#endif

char *
nxo_string_get(const cw_nxo_t *a_nxo);

void
nxo_string_set(cw_nxo_t *a_nxo, uint32_t a_offset, const char *a_str,
	       uint32_t a_len);
